@Filename: AdcRef.s
@Part: ADuC702x.
@Created: 15/04/2004
@Updated: 28/06/2005
@Author: Eckart Hartmann.
@This file is in beta sampling.

.include        "ADuC7020.equ"
.ARM


@ AdcRef==========Chooses the reference for the ADC.
@ C Function prototype: int AdcRef(int iRef);
@iRef:{REF_INT,REF_EXT}
@ Description of Function: Chooses the reference for the ADC.
@ User interface:
@   Set iRef to one of the following:
@       1 or REF_INT to use the internal reference for the ADC.
@       2 or REF_EXT to use an external reference for the ADC.
@       Other value will leave reference selection unchanged.
@   Call AdcRef.
@       Returns 0, 1 or 2 depending on previous reference selection.
@ Robustness:  iRef = 1 is not useable since the internal reference 
@               must be connected to a 470uF capacitor.
@ Side effects: Corrupts r3 and r1.

.GLOBAL AdcRef
AdcRef:
        mov     r3,#0xff0000            @r3 = Z_BASE;
        orr     r3,r3,#0xff000000
        mov     r1,r0
        ldr     r0,[r3,#REFCON_OFFSET]  @Return value.
        cmp     r1,#3                   @if(iRef<3)
        strlo   r1,[r3,#REFCON_OFFSET]  @ REFCON = iRef;
        bx      lr                      @return REFCON.

